package com.gct.aoid.aop;

import java.lang.annotation.ElementType;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;
import java.lang.annotation.Target;

@Target(ElementType.METHOD)
@Retention(RetentionPolicy.RUNTIME)
public @interface FeignCache {

    /**
     * 指定缓存失效时间
     * 注意：所有的缓存都应该指定一个合适的缓存时间，项目启动时会自动删除feign-client的缓存
     * 如果不指定，则缓存将一直存在，直到下次项目重启
     * @return 缓存失效时间，单位：秒
     */
    long expiresIn() default -1;
}
