package com.gct.aoid.controller;


import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.gct.aoid.entity.Vo.AoidYeildVo;
import com.gct.aoid.service.AoidSinglegtYieldService;

import com.gct.common.core.result.Result;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.text.ParseException;
import java.time.LocalDate;
import java.time.format.DateTimeFormatter;
import java.util.List;
import java.util.Map;

/**
 * <p>
 * 前端控制器
 * </p>
 *
 * @author gxt
 * @since 2021-01-31
 */
@Api(value = "AoidSinglegtYieldController", description = "功图量液")
@RestController
@RequestMapping("/aoidSinglegtYield")
public class AoidSinglegtYieldController {

    @Autowired  
    public AoidSinglegtYieldService aoidSinglegtYieldService;



    @ApiOperation(value = "根据井号和日期时间段查询量液的基本信息" ,notes = "根据井号和日期时间段查询量液的基本信息")
    @PostMapping("/getAoidSinglegtYieldInfo")
    public Result getAoidSinglegtYieldInfoByWellIdAndPorDatePeriod(@RequestBody AoidYeildVo aoidYeildVo){
       List list= aoidSinglegtYieldService.getAoidSinglegtYieldListByOneDay(aoidYeildVo.getWellId(),aoidYeildVo.getStartDate());
        return list==null||list.size()==0?Result.error("量液信息未找到"):Result.ok(list);
    }

    @ApiOperation(value = "根据井号和日期时间段查询量液的基本信息--分页" ,notes = "根据井号和日期时间段查询量液的基本信息--分页")
    @PostMapping("/getAoidSinglegtYieldInfoByPages")
    public Result getAoidSinglegtYieldInfoByWellIdAndPorDatePeriodAndPages(@RequestBody AoidYeildVo aoidYeildVo) throws ParseException {
        String datePattern = "\\d{4}-\\d{1,2}-\\d{1,2}";
        if(aoidYeildVo.getStartDate()==null){
            LocalDate now = LocalDate.now();
            aoidYeildVo.setStartDate(now.format(DateTimeFormatter.ISO_DATE));
            aoidYeildVo.setEndDate(now.plusDays(1).format(DateTimeFormatter.ISO_DATE));
        }
        if (aoidYeildVo.getStartDate()==null||aoidYeildVo.getEndDate()==null ||!aoidYeildVo.getStartDate().matches(datePattern) || !aoidYeildVo.getEndDate().matches(datePattern))
            return Result.error("日期格式有误");

        Page<Map<String,Object>> mapPage =  aoidSinglegtYieldService.getAoidSinglegtYieldInfoByWellIdAndPorDatePeriodAndPages(
                aoidYeildVo.getWellId(),
                aoidYeildVo.getStartDate(),
                aoidYeildVo.getEndDate(),
                aoidYeildVo.getPage(),
                aoidYeildVo.getSize());
        return mapPage==null||mapPage.getSize()==0?Result.error("未找到"):Result.ok(mapPage);
    }

    @GetMapping("/getResultIdByWellId")
    public Result getResultIdByWellId(@RequestParam String wellId,@RequestParam String date,@RequestParam boolean isOnlyShowErrorGt,
                                      @RequestParam("pageSize") int pageSize ,@RequestParam("pageNum") int pageNum){
        return Result.ok(aoidSinglegtYieldService.getResultIdByWellId(wellId,date,isOnlyShowErrorGt,pageSize,pageNum));
    }

    @ApiOperation(value = "功图浏览", notes = "根据参数条件进行功图浏览")
    @GetMapping("/getCvrresultByTimeBrowSingle")
    public Result getCvrresultByTimeBrowSingle(
            @ApiParam("开始时间") @RequestParam(required = false) String beginTime,
            @ApiParam("结束时间") @RequestParam(required = false) String endTime,
            @ApiParam("orgid") @RequestParam(required = false) String orgid,
            @ApiParam("井号") @RequestParam(required = false) String wellId,
            @ApiParam("判断功图是否异常") @RequestParam(required = false) Integer sgtIsLegal,
            @ApiParam("当前页") @RequestParam Integer pageNum,
            @ApiParam("页面大小") @RequestParam Integer pageSize) {
        return Result.ok(aoidSinglegtYieldService.getCvrresultByTimeBrowSingle(beginTime, endTime,orgid, wellId,sgtIsLegal, pageNum, pageSize));
    }
}

