package com.gct.aoid.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * <p>
 * 液量异常信息表(动态存储)
 * </p>
 *
 * @author gxt
 * @since 2022-08-15
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value="AoidLiquidAbnormalDynamic对象", description="液量异常信息表(动态存储)")
@TableName(schema = "aoid",value = "aoid_liquid_abnormal_dynamic")
public class AoidLiquidAbnormalDynamic extends Model<AoidLiquidAbnormalDynamic> {

    private static final long serialVersionUID=1L;


    @TableId(type = IdType.ASSIGN_ID)
    private String id;

    @ApiModelProperty(value = "井号")
    private String wellId;

    @ApiModelProperty(value = "作业区")
    private String workArea;

    @ApiModelProperty(value = "井区")
    private String wellArea;

    @ApiModelProperty(value = "站点")
    private String station;

    @ApiModelProperty(value = "日产液量 t(实际产量)")

    private Double liqProdDaily;

    @ApiModelProperty(value = "诊断结果")
    private String origin;

    @ApiModelProperty(value = "日期")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private LocalDateTime prodDate;

    @ApiModelProperty(value = "油嘴")
    private Double oilMouth;

    @ApiModelProperty(value = "泵径")
    private Double pumpDiameter;

    @ApiModelProperty(value = "油压")
    private Double oilPressure;

    @ApiModelProperty(value = "套压")
    private Double sheathPressure;

    @ApiModelProperty(value = "回压")
    private Double backPressure;

    @ApiModelProperty(value = "液量异常的详细信息")
    private String liquidInfo;


    @Override
    protected Serializable pkVal() {
        return null;
    }

}
