package com.gct.aoid.entity;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;

/**
 * <p>
 * 液量异常阈值设置
 * </p>
 *
 * @author gxt
 * @since 2022-08-15
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value="AoidLiquidThreshold对象", description="液量异常阈值设置")
@TableName(schema = "aoid",value = "aoid_liquid_threshold")
public class AoidLiquidThreshold extends Model<AoidLiquidThreshold> {

    private static final long serialVersionUID=1L;

    @TableId(type = IdType.ASSIGN_ID)
    private String id;

    @ApiModelProperty(value = "对比什么时间")
    private String requirement;

    @ApiModelProperty(value = "作业区总产液量的阈值,默认是10%")
    private Double workAreaThreshold;

    @ApiModelProperty(value = "液量范围开始")
    private Double liquidVolumeStart;

    @ApiModelProperty(value = "液量范围结束")
    private Double liquidVolumeEnd;

    @ApiModelProperty(value = "液量阈值(t)")
    private Double thresholdLiq;

    @ApiModelProperty(value = "含水率阈值(%)")
    private Double thresholdWaterCut;

    @ApiModelProperty(value = "属于谁,单井,站,井区,作业区,都可以")
    private String appertain;


    @Override
    protected Serializable pkVal() {
        return null;
    }

}
