package com.gct.aoid.entity.MQ;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.time.LocalDateTime;

/**
 * class name: DiagnoseResult
 *
 * @author gxt
 * @version 1.0
 * @since 2022/9/23 下午2:05 周五
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value="DiagnoseResult", description="诊断结果对象")
public class DiagnoseResult {
    @ApiModelProperty(value = "id")
    private String id;

    @ApiModelProperty(value = "一次诊断结果")
    private String result1;

    @ApiModelProperty(value = "专家经验公式诊断结果")
    private String result2;

    @ApiModelProperty(value = "井号")
    private String wellId;

    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd HH:mm:ss", timezone = "GMT+8")
    private LocalDateTime prodDateTime;

    @ApiModelProperty(value = "示功图")
    private String sgt;

    @ApiModelProperty(value = "备注")
    private String remark;
}
