package com.gct.aoid.entity;

import com.baomidou.mybatisplus.annotation.FieldFill;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableName;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.io.Serializable;
import java.time.LocalDateTime;

/**
 * <p>
 * 标准理论模型
 * </p>
 *
 * @author gxt
 * @since 2022-09-13
 */
@Data
@EqualsAndHashCode(callSuper = false)
@Accessors(chain = true)
@ApiModel(value="StandardTheoryModel对象", description="标准理论模型")
@TableName(schema = "aoid",value = "standard_theory_model")
public class StandardTheoryModel extends Model<StandardTheoryModel> {

    private static final long serialVersionUID=1L;

    private String wellId;

    private LocalDateTime prodDate;

    @ApiModelProperty(value = "模型类型")
    private String modelType;

    @ApiModelProperty(value = "模型数据")
    private String modelData;

    @TableField(fill = FieldFill.INSERT)
    private LocalDateTime createTime;


    @Override
    protected Serializable pkVal() {
        return null;
    }

}
