package com.gct.aoid.feignclient;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.gct.aoid.aop.FeignCache;
import com.gct.aoid.entity.WellAttr;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * class name: BaseDataClient
 *
 * @author lloyd
 * @version 1.0
 * @since 2021/1/25 下午6:02
 */
@FeignClient(value = "centralbase", fallback = BaseDataHystrix.class)
public interface    BaseDataClient {
    @RequestMapping(value = "/getLatestA2DailyData/{WellID}", method = RequestMethod.GET)
    String getLatestA2DailyData(@PathVariable("WellID") String wellID);

    @RequestMapping(value = "/WellSeriesInfo/WellSeriesInfo", method = RequestMethod.GET)
    String getWellSeriesInfo();

    @RequestMapping(value = "/cbPcProWellboreStatusDaily/getA2DataForCalProduction/{WellName}/{dateTime}", method = RequestMethod.GET)
    String getA2StatusDataForCalProduction(@PathVariable("WellName") String wellName, @PathVariable("dateTime") String dateTime);



    @RequestMapping(value = "/cbPcProWellboreVolDaily/getA2DataForCalVolDaily/{WellName}/{dateTime}", method = RequestMethod.GET)
    String getA2VolDataForCalProduction(@PathVariable("WellName") String wellName, @PathVariable("dateTime") String dateTime);

    @RequestMapping(value = "/cbPcDevWellAttr/selectOneByWellId", method = RequestMethod.GET)
    String selectOneByWellId(@RequestParam("well_id") String well_id);

    @RequestMapping(value = "/cbPcDevWellAttr/selectOneByWellIdSeparator", method = RequestMethod.GET)
    String selectOneByWellIdSeparator( @RequestParam("wellId")  String wellId,
                                       @RequestParam("jobSystem")  String jobSystem);

    @RequestMapping(value = "/WellSource/jh", method = RequestMethod.GET)
    String getWellListByOrgID(@RequestParam("orgid") String org);

    @RequestMapping("/org/getOrgId/{orgId}")
    String getOrgId(@PathVariable("orgId") String orgId);


    @FeignCache
    @GetMapping("/org/getOrgByWellId/{wellId}")
    String getOrgByWellId(@PathVariable("wellId") String wellId);

    @GetMapping("/org/getMaxLevelOrgId")
    String getMaxLevelOrgId();

    @GetMapping("/cbCdWellSource/getjhAll")
    String getjhAll();

    @GetMapping("/cbCdWellSource/getjhAllByorgid")
    String getjhAllByorgid(@RequestParam String orgid);

    @PostMapping("/cbPcDevWellAttr/addCbPcDevWellAttr")
    String addCbPcDevWellAttr(@RequestBody WellAttr wellattr);

    @GetMapping("/cbPcDevWellAttr/updatePzxs")
    String updatePzxs(@RequestParam("well_id") String well_id,@RequestParam("pzxh") double pzxh);

    @GetMapping("/cbPcDevWellAttr/updateis")
    String updateis(@RequestParam("well_id") String well_id,@RequestParam("sfpp") String sfpp,@RequestParam("dateTime") String dateTime,@RequestParam("fl") String fl);

    @GetMapping("/cbPcDevWellAttr/updateisempty")
    String updateisempty(@RequestParam("well_id") String well_id);


    @GetMapping("/org/getWellIdsByOrgIds")
    String getWellIdsByOrgIds(@RequestParam List<String> orgIds);

    @RequestMapping(value = "/CbPcProWellMeterTeam/getWellMeterTeamForCalProduction", method = RequestMethod.GET)
    String getWellMeterTeamForCalProduction(@RequestParam("WellName") String wellName, @RequestParam("dateTime") String dateTime);

    @GetMapping("/org/getParAndSonOrg")
    String getParAndSonOrg(@RequestParam JSONArray orgStr);

    @GetMapping("/org/getOrgInfoByWellID")
    String getOrgInfoByWellID(@RequestParam String wellId);

    @GetMapping("/WellSource/jh")
    String getJh(@RequestParam("orgid") String orgid);

    @GetMapping ("/WellSource/getWellSourceByWellIdList")
    String getWellSourceByWellIdList(@RequestParam List<String> wellId);

    @GetMapping ("/WellSource/getWellSource")
    String getWellSource(@RequestParam String wellId);

    @RequestMapping(value = "/cbCdWellSource/getByWellId_Heavy", method = RequestMethod.GET)
    String getByWellId_Heavy(@RequestParam("wellName") String wellName);


    @GetMapping("/cbTempWellMechRuntime/getAllRuntimeData")
    String getAllRuntimeData();

    @PostMapping("/WellSource/getWellInfoByList")
    String getWellInfoByList(@RequestBody List<String> wellId);

    @GetMapping("/accessWell/getWellControlList")
    String getWellControlList();

    @RequestMapping(value = "/cbPcDevWellAttr/getCbPcDevWellAttrMaxUpdateTime", method = RequestMethod.GET)
    String getCbPcDevWellAttrMaxUpdateTime(@RequestParam("wellId") String wellId,@RequestParam("realDate") String realDate,@RequestParam("flag") String flag);

    @GetMapping("/cbCdWellSource/getjhAllYieldError")
    String getjhAllYieldError();

    @GetMapping("/cbCdWellSource/getjhAllConent")
    String getjhAllConent();



    @RequestMapping(value = "/cbPcDevWellAttr/selectOneByWellIdList", method = RequestMethod.GET)
    String selectOneByWellIdList(@RequestParam("wellId") String wellId);

    @GetMapping("/org/getAllOrgs")
    String getAllOrganizations();
    @PostMapping("/CbPcProWellMeterTeam/list")
    String getWellMeterTeamList(@RequestBody JSONObject jsonObject);
}
