package com.gct.aoid.job;

import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.gct.aoid.entity.AoidDailyYield;
import com.gct.aoid.entity.AoidSinglegtYield;
import com.gct.aoid.feignclient.BaseDataClient;
import com.gct.aoid.service.AoidDailyYieldService;
import com.gct.aoid.service.AoidSinglegtYieldService;
import com.gct.common.core.result.Result;
import com.gct.common.util.DateTimeUtil;
import org.quartz.JobExecutionContext;
import org.quartz.JobExecutionException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.quartz.QuartzJobBean;

import java.io.*;
import java.nio.file.Files;
import java.time.Duration;
import java.time.LocalDate;
import java.time.LocalDateTime;
import java.util.List;
import java.util.Map;

/**
 * class name: getData
 *
 * @author gxt
 * @version 1.0
 * @since 2022/9/8 下午4:54 周四
 */
public class getData extends QuartzJobBean {
    @Autowired
    AoidSinglegtYieldService aoidSinglegtYieldService;
    @Autowired
    AoidDailyYieldService aoidDailyYieldService;
    @Autowired
    BaseDataClient baseDataClient;

    @Override
    protected void executeInternal(JobExecutionContext context) throws JobExecutionException {
        JSONObject jsonObject = new JSONObject();
        jsonObject.put("cuttentPage", 1);
        jsonObject.put("pageSize", 5000);
        jsonObject.put("wellId", null);
        jsonObject.put("ids", null);
        Map<String, Object> map = JSONObject.parseObject(JSON.toJSONString(JSONObject.parseObject(baseDataClient.getWellMeterTeamList(jsonObject), Result.class).getData()), Map.class);
        List<Map<String, String>> records = JSONObject.parseObject(JSON.toJSONString(map.get("records")), List.class);
        writeData(JSON.toJSONString(records), "team.txt");
        LocalDateTime localDateTime = DateTimeUtil.formatDateTime(LocalDate.now().minusDays(2) + " 00:00:00");
        LocalDateTime now = DateTimeUtil.formatDateTime(LocalDate.now() + " 00:00:00");
        long days = Duration.between(localDateTime, now).toDays();
        for (int i = 0; i <= days; i++) {
            int finalI = i;
            List<AoidSinglegtYield> singlegtYieldList = aoidSinglegtYieldService.getBaseMapper().selectList(new LambdaQueryWrapper<AoidSinglegtYield>()
                    .ge(AoidSinglegtYield::getProdDate, localDateTime.plusDays(i))
                    .le(AoidSinglegtYield::getProdDate, localDateTime.plusDays(i + 1)));
            if (!singlegtYieldList.isEmpty()) {
                singlegtYieldList.forEach(x -> writeData(JSON.toJSONString(x), "singlegt" + localDateTime.plusDays(finalI).toLocalDate() + ".txt"));
            }
            List<AoidDailyYield> dailyYieldList = aoidDailyYieldService.getBaseMapper().selectList(new LambdaQueryWrapper<AoidDailyYield>()
                    .ge(AoidDailyYield::getProdDate, localDateTime.plusDays(i))
                    .le(AoidDailyYield::getProdDate, localDateTime.plusDays(i + 1)));
            if (!dailyYieldList.isEmpty())
                dailyYieldList.forEach(x -> writeData(JSON.toJSONString(x), "daily" + localDateTime.plusDays(finalI).toLocalDate() + ".txt"));
        }
    }

    private void writeData(String data, String name) {
        try {
            File file = new File("./"+name);
            BufferedWriter out = null;
            if (!file.exists()) {
                if (file.createNewFile())
                    out = new BufferedWriter(new OutputStreamWriter(Files.newOutputStream(file.toPath())));
            } else {
                out = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(file, true)));
            }
            assert out != null;
            out.write(data + "\n");
            out.flush();
            out.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}
