package com.gct.aoid.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.gct.aoid.entity.AoidLiquidThreshold;
import com.gct.aoid.entity.Vo.SaveThresholdVo;
import com.gct.aoid.feignclient.BaseDataClient;
import com.gct.aoid.mapper.AoidLiquidThresholdMapper;
import com.gct.aoid.service.AoidLiquidThresholdService;
import com.gct.common.util.StringUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * <p>
 * 液量异常阈值设置 服务实现类
 * </p>
 *
 * @author gxt
 * @since 2022-08-15
 */
@Service
public class AoidLiquidThresholdServiceImpl extends ServiceImpl<AoidLiquidThresholdMapper, AoidLiquidThreshold> implements AoidLiquidThresholdService {

    @Autowired
    BaseDataClient baseDataClient;

    @Override
    public List<AoidLiquidThreshold> getThresholdList(String appertain) {
        LambdaQueryWrapper<AoidLiquidThreshold> wrapper = new LambdaQueryWrapper<>();
        if (!StringUtil.isBlankOrEmpty(appertain)) {
            wrapper = wrapper.eq(AoidLiquidThreshold::getAppertain, appertain);
        }
        wrapper = wrapper.orderByAsc(AoidLiquidThreshold::getThresholdLiq);
        return baseMapper.selectList(wrapper);
    }

    @Override
    public boolean saveThresholdList(SaveThresholdVo saveThresholdVo) {
         baseMapper.delete(new LambdaQueryWrapper<AoidLiquidThreshold>()
                .eq(AoidLiquidThreshold::getAppertain, saveThresholdVo.getLiquidThresholds().get(0).getAppertain()));
        return saveBatch(saveThresholdVo.getLiquidThresholds());
    }
}
