package com.gct.aoid.service.impl;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.update.LambdaUpdateWrapper;
import com.gct.aoid.algorithm.CalDiagramProduction;
import com.gct.aoid.algorithm.CalDiagramProductionCopy;
import com.gct.aoid.algorithm.CalPumpCard;
import com.gct.aoid.algorithm.CalPumpCardCopy;
import com.gct.aoid.entity.*;
import com.gct.aoid.feignclient.BaseDataClient;
import com.gct.aoid.feignclient.DiagnoseClient;
import com.gct.aoid.rocketmq.AoidMsg;
import com.gct.aoid.service.*;
import com.gct.common.core.result.Result;
import com.gct.common.util.SGTUtil;
import lombok.extern.slf4j.Slf4j;
import org.slf4j.Logger;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.messaging.MessagingException;
import org.springframework.stereotype.Component;

import java.io.FileNotFoundException;
import java.lang.reflect.InvocationTargetException;
import java.sql.ResultSet;
import java.text.SimpleDateFormat;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Objects;

/**
 * class name: CalDiagramProductionService
 * @explain 量液服务类
 * @author lloyd
 * @version 1.0
 * @since 2021/1/29 下午9:47
 */
@Component
@Slf4j
public class calDiagramProductionCorrectService {

    @Autowired
    private BaseDataClient baseDataClient;
    @Autowired
    private AoidGkHeavyModelService aoidGkHeavyModelService;
    @Autowired
    private AoidSinglewellConfigService aoidSinglewellConfigService;
    @Autowired
    private CalPumpCard calPumpCard;
    @Autowired
    private CalDiagramProduction calDiagramProduction;
    @Autowired
    private AoidSinglegtYieldService aoidSinglegtYieldService;


    /**
     *单井属性定时运行
     * @throws InvocationTargetException
     * @throws IllegalAccessException
     * @throws InstantiationException
     * @throws NoSuchMethodException
     */
    public void calxz()  {

        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        Date date_start = new Date(new Date().getTime()-24*60*60*1000);
        Date date_end = new Date(new Date().getTime());
        String time_start = sdf.format(date_start);
        String time_end = sdf.format(date_end);
        String time_start1 = time_start+" 00:00:00";
        String time_end1 = time_end+" 23:59:59";
        String datetime_now_input= LocalDateTime.now().format(DateTimeFormatter.ofPattern("yyyy-MM-dd"));
        String datetime_now = datetime_now_input+" 00:00:00.000";
        ProDataForCalProduction WellAttrdata;
        String baseParam = baseDataClient.getjhAll();
        Result result = JSONObject.parseObject(baseParam, Result.class);
        Object data = result.getData();
        JSONArray jsonArray = JSONArray.parseArray(data.toString());
        for (int i = 0; i < jsonArray.size(); i++) {
            double a2 =0;
            double bj =0;
            String zdjg ="";
            String ismatching="否";
            double nd = 5631.1;
            String bjyy="";
            String ismatching_success="是";
            JSONObject jo = jsonArray.getJSONObject(i);
            String wellId = jo.getString("wellId");
            String orgid = jo.getString("orgId");
            String jh= baseDataClient.selectOneByWellId(wellId);
            Result jhresult = JSONObject.parseObject(jh, Result.class);
            Object jhbasedata = jhresult.getData();
            if (jhbasedata!=null)
            {
                baseDataClient.updateisempty(wellId);
            }
            List<AoidSinglegtYield> result1 = aoidSinglegtYieldService.findByJhbase(wellId,time_start1,time_end1);
            if(result1.size()>0)
            {

                try {
                    Thread.sleep(3000);
                    a2 = result1.get(0).getA2LiqProdDaily();
                    bj =result1.get(0).getBj();
                    zdjg = result1.get(0).getZdjg();

                    String ismatchingbase = baseDataClient.selectOneByWellId(wellId);
                    Result ismatchingbaseresult = JSONObject.parseObject(ismatchingbase, Result.class);
                    Object ismatchingbasedata = ismatchingbaseresult.getData();
                    if(ismatchingbasedata!=null)
                    {
                        updatepzxs(a2,bj,zdjg,result1,wellId,nd,bjyy,ismatching,ismatching_success,datetime_now);
                    }
                    else {
                        insertpzxs(a2,bj,zdjg,result1, orgid,wellId,nd,bjyy,ismatching,ismatching_success,datetime_now);
                    }
                } catch (InterruptedException e) {
                    e.printStackTrace();
                }

            }


        }
    }


//    /**
//     * 相邻区域应用系数
//     * @param wellId
//     * @param coefficient
//     */
//    public void regioncoefficient(String wellId,double coefficient )
//    {
//
//        String wellInfoByWellId = baseDataClient.getWellSource(wellId);
//
//        System.out.println(wellInfoByWellId);
//
//    }


    /**
     * 指定参数进行计算
     * @param datetime
     * @param org_id
     * @param wellid
     * @throws InvocationTargetException
     * @throws IllegalAccessException
     * @throws InstantiationException
     * @throws NoSuchMethodException
     */
    public void parametercalculation(String datetime,String org_id,String wellid)  {

        String time_start1 = datetime+" 00:00:00";
        String time_end1 = datetime+" 23:59:59";
        String datetime_now_input= LocalDateTime.now().format(DateTimeFormatter.ofPattern("yyyy-MM-dd"));
        String datetime_now = datetime_now_input+" 00:00:00.000";
        ProDataForCalProduction WellAttrdata;
        String bjyy="";
        if (wellid == null || wellid.length() == 0)
        {
            parametercalculationbyorg(datetime,org_id);
        }
        else {
            double a2 =0;
            double bj =0;
            String zdjg ="";
            double nd = 5631.1;
            String ismatching="否";
            String ismatching_success="是";
            String jh= baseDataClient.selectOneByWellId(wellid);
            Result jhresult = JSONObject.parseObject(jh, Result.class);
            Object jhbasedata = jhresult.getData();
            if (jhbasedata!=null)
            {
                baseDataClient.updateisempty(wellid);
            }
            List<AoidSinglegtYield> result1 = aoidSinglegtYieldService.findByJhbasecs(wellid,time_start1,time_end1);
            if(result1.size()>0)
            {
                try {
                    Thread.sleep(3000);
                    a2 = result1.get(0).getA2LiqProdDaily();
                    bj =result1.get(0).getBj();
                    zdjg = result1.get(0).getZdjg();

                    String ismatchingbase = baseDataClient.selectOneByWellId(wellid);
                    Result ismatchingbaseresult = JSONObject.parseObject(ismatchingbase, Result.class);
                    Object ismatchingbasedata = ismatchingbaseresult.getData();
                    if(ismatchingbasedata!=null)
                    {
                        updatepzxs(a2,bj,zdjg,result1,wellid,nd,bjyy,ismatching,ismatching_success,datetime_now);
                    }
                    else {
                        insertpzxs(a2,bj,zdjg,result1, org_id,wellid,nd,bjyy,ismatching,ismatching_success,datetime_now);
                    }
                } catch (InterruptedException e) {
                    log.error("井号："+wellid+"单井属性出现异常详情："+e.getMessage());
                    e.printStackTrace();
                }
            }
        }

    }


    /**
     * 指定参数进行计算（针对井号为空）
     * @param datetime
     * @param org_id
     * @throws InvocationTargetException
     * @throws IllegalAccessException
     * @throws InstantiationException
     * @throws NoSuchMethodException
     */
    public void parametercalculationbyorg(String datetime,String org_id)   {

        String time_start1 = datetime+" 00:00:00";
        String time_end1 = datetime+" 23:59:59";
        String datetime_now_input= LocalDateTime.now().format(DateTimeFormatter.ofPattern("yyyy-MM-dd"));
        String datetime_now = datetime_now_input+" 00:00:00.000";
        String bjyy="";
        ProDataForCalProduction WellAttrdata;

        String baseParam = baseDataClient.getJh(org_id);
        //String baseParam = baseDataClient.getjhAllByorgid(org_id);
        Result result = JSONObject.parseObject(baseParam, Result.class);
        Object data = result.getData();
        JSONArray jsonArray = JSONArray.parseArray(data.toString());
        for (int i = 0; i < jsonArray.size(); i++) {
            double a2 =0;
            double bj =0;
            String zdjg ="";
            double nd = 5631.1;
            String ismatching="否";
            String ismatching_success="是";
            JSONObject jo = jsonArray.getJSONObject(i);
            String wellId = jo.getString("id");
            String jh= baseDataClient.selectOneByWellId(wellId);
            Result jhresult = JSONObject.parseObject(jh, Result.class);
            Object jhbasedata = jhresult.getData();
            if (jhbasedata!=null)
            {
                baseDataClient.updateisempty(wellId);
            }
            List<AoidSinglegtYield> result1 = aoidSinglegtYieldService.findByJhbasecs(wellId,time_start1,time_end1);
            if(result1.size()>0)
            {

                try {
                    Thread.sleep(3000);
                    a2 = result1.get(0).getA2LiqProdDaily();
                    bj =result1.get(0).getBj();
                    zdjg = result1.get(0).getZdjg();

                    String ismatchingbase = baseDataClient.selectOneByWellId(wellId);
                    Result ismatchingbaseresult = JSONObject.parseObject(ismatchingbase, Result.class);
                    Object ismatchingbasedata = ismatchingbaseresult.getData();
                    if(ismatchingbasedata!=null)
                    {
                        updatepzxs(a2,bj,zdjg,result1,wellId,nd,bjyy,ismatching,ismatching_success,datetime_now);
                    }
                    else {
                        insertpzxs(a2,bj,zdjg,result1, org_id,wellId,nd,bjyy,ismatching,ismatching_success,datetime_now);

                    }
                } catch (InterruptedException e) {
                    log.error("井号："+wellId+"单井属性出现异常详情："+e.getMessage());
                    e.printStackTrace();
                }
            }


        }
    }


    /**
     * 根据现有单井属性进行修改
     * @param a2
     * @param bj
     * @param zdjg
     * @param result1
     * @param wellId
     * @param nd
     * @param bjyy
     * @param ismatching
     * @param ismatching_success
     * @param datetime_now
     */
    public  void updatepzxs(double a2,double bj,String zdjg,List<AoidSinglegtYield> result1,String wellId,double nd,String bjyy,String ismatching,
                            String ismatching_success,String datetime_now) {
        if(!"-1".equals(zdjg))
        {

            double u =0; double d =10;
            double pre_pzxs =10;

            while (d-u>1e-6){
                double xs = (u+d)/2;
                double rclyxzsum=0.0;
                double data[] = new double[result1.size()];
                List<Double> list = new ArrayList<>();
                for (int n =0; n< result1.size(); n++)
                {
                    data[n] += calWrapper(wellId,result1.get(n).getSgt(),
                            result1.get(n).getStroke(),result1.get(n).getSgtIsLegal(),result1.get(n).getFrequence(),
                            result1.get(n).getEczdjg(),result1.get(n).getZdjg(),result1.get(n).getBj(),result1.get(n).getBs(),
                            result1.get(n).getHsl(),result1.get(n).getSmd(),result1.get(n).getYmd(),result1.get(n).getQyb(),
                            result1.get(n).getA2Dym(),xs,nd);
                }

                for (int f=0; f<data.length;f++)
                {
                    list.add(data[f]);
                    List<Double> filters = new ArrayList<>();
                    filters.add(0.0);
                    list.removeAll(filters);

                }

                for (int p=0;p<list.size();p++)
                {
                    rclyxzsum+=list.get(p);
                }
                double production = rclyxzsum/list.size();

                if(production-a2>a2*0.1)d=xs;
                else if(a2-production>a2*0.1)
                {
                    u =xs;
                }
                else
                {
                    if(Math.abs((u+d)/2)<0.1 || Math.abs((u+d)/2)>10 ||Math.abs(pre_pzxs-(u+d)/2)<=0.01)
                    {
                        bjyy="否";
                        break;
                    }
                    if(a2-production>a2*0.1){
                        u=xs;
                    }else if (production-a2>a2*0.1){
                        d=xs;
                    }
                }
                pre_pzxs =(u+d)/2;
            }
            double xs2 = (u+d)/2;

            if (bjyy=="否")
            {
                String produ = "1";
                String produ1 = "2";
                String oneStr =  baseDataClient.getByWellId_Heavy(wellId);
                Result result = JSONObject.parseObject(oneStr, Result.class);
                Object resultdata = result.getData();
                baseDataClient.updatePzxs(wellId,xs2);

                if (resultdata != null)
                {
                    baseDataClient.updateis(wellId,ismatching,datetime_now,produ1);
                }
                else
                {
                    baseDataClient.updateis(wellId,ismatching,datetime_now,produ);
                }

//                regioncoefficient(wellId,xs2);
            }
            else {
                String produ = "1";
                String produ1 = "2";
                String oneStr =  baseDataClient.getByWellId_Heavy(wellId);
                Result result = JSONObject.parseObject(oneStr, Result.class);
                Object resultdata = result.getData();
                baseDataClient.updatePzxs(wellId,xs2);
                if (resultdata != null)
                {
                    baseDataClient.updateis(wellId,ismatching_success,datetime_now,produ1);
                }
                else
                {
                    baseDataClient.updateis(wellId,ismatching_success,datetime_now,produ);
                }
            }

        }
    }

    /**
     * 根据未添加单井属性的井进行完善
     * @param a2
     * @param bj
     * @param zdjg
     * @param result1
     * @param wellId
     * @param orgid
     * @param nd
     * @param bjyy
     * @param ismatching
     * @param ismatching_success
     * @param datetime_now
     */
    public  void insertpzxs(double a2,double bj,String zdjg,List<AoidSinglegtYield> result1,String orgid,String wellId,double nd,String bjyy,String ismatching,
                            String ismatching_success,String datetime_now) {
        if(!"-1".equals(zdjg))
        {

            double u =0; double d =10;
            double pre_pzxs =10;
            while (d-u>1e-6){
                double xs = (u+d)/2;
                double rclyxzsum=0.0;
                double data[] = new double[result1.size()];
                List<Double> list = new ArrayList<>();
                for (int n =0; n< result1.size(); n++)
                {
                    data[n] +=  calWrapper(result1.get(n).getWellId(),result1.get(n).getSgt(),
                            result1.get(n).getStroke(),result1.get(n).getSgtIsLegal(),result1.get(n).getFrequence(),
                            result1.get(n).getEczdjg(),result1.get(n).getZdjg(),result1.get(n).getBj(),result1.get(n).getBs(),
                            result1.get(n).getHsl(),result1.get(n).getSmd(),result1.get(n).getYmd(),result1.get(n).getQyb(),
                            result1.get(n).getA2Dym(),xs,nd);
                }
                for (int f=0; f<data.length;f++)
                {
                    list.add(data[f]);
                    List<Double> filters = new ArrayList<>();
                    filters.add(0.0);
                    list.removeAll(filters);

                }

                for (int p=0;p<list.size();p++)
                {
                    rclyxzsum+=list.get(p);
                }
                double production = rclyxzsum/list.size();
                if(production-a2>a2*0.1)d=xs;
                else if(a2-production>a2*0.1)
                {
                    u =xs;
                }
                else
                {
                    if(Math.abs((u+d)/2)<0.1 || Math.abs((u+d)/2)>10 ||Math.abs(pre_pzxs-(u+d)/2)<=0.1)
                    {
                        bjyy="否";
                        break;
                    }
                    if(a2-production>a2*0.1){
                        u=xs;
                    }else if (production-a2>a2*0.1){
                        d=xs;
                    }
                }
                pre_pzxs =(u+d)/2;
            }
            double xs2 = (u+d)/2;
            if (bjyy=="否")
            {
                WellAttr wellAttr = new WellAttr();
                String produ = "1";
                String produ1 = "2";
                String wellbase = baseDataClient.selectOneByWellId(wellId);
                Result wellbaseresult = JSONObject.parseObject(wellbase, Result.class);
                Object wellbasedata = wellbaseresult.getData();
                if(wellbasedata==null)
                {

                    String oneStr =  baseDataClient.getByWellId_Heavy(wellId);
                    Result result = JSONObject.parseObject(oneStr, Result.class);
                    Object resultedata = result.getData();
                    if (resultedata != null)
                    {
                        wellAttr.setOilProductsSorting(produ1);
                    }
                    else
                    {
                        wellAttr.setOilProductsSorting(produ);
                    }
                    wellAttr.setOrgId(orgid);
                    wellAttr.setWellId(wellId);
                    wellAttr.setCoefficient(xs2);
                    wellAttr.setIsmatching(ismatching);
                    wellAttr.setUpdateTime(datetime_now);
                    baseDataClient.addCbPcDevWellAttr(wellAttr);
                }
            }
            else {
                WellAttr wellAttr = new WellAttr();
                String produ = "1";
                String produ1 = "2";

                String wellbase = baseDataClient.selectOneByWellId(wellId);
                Result wellbaseresult = JSONObject.parseObject(wellbase, Result.class);
                Object wellbasedata = wellbaseresult.getData();
                if(wellbasedata==null)
                {
                    wellAttr.setWellId(wellId);
                    String oneStr =  baseDataClient.getByWellId_Heavy(wellId);
                    Result result = JSONObject.parseObject(oneStr, Result.class);
                    Object resultedata = result.getData();
                    if (resultedata != null)
                    {
                        wellAttr.setOilProductsSorting(produ1);
                    }
                    else
                    {
                        wellAttr.setOilProductsSorting(produ);
                    }
                    wellAttr.setOrgId(orgid);
                    wellAttr.setCoefficient(xs2);
                    wellAttr.setIsmatching(ismatching_success);
                    wellAttr.setUpdateTime(datetime_now);
                    baseDataClient.addCbPcDevWellAttr(wellAttr);
                }
            }

        }
    }

    /**
     * 量液入口
     * @param wellid
     * @param sgt
     * @param stroke
     * @param sgtIsLegal
     * @param frequence
     * @param eczdjg
     * @param zdjg
     * @param bj
     * @param bs
     * @param hsl
     * @param smd
     * @param ymd
     * @param qyb
     * @param dym
     * @param pzxs
     * @throws InvocationTargetException
     * @throws IllegalAccessException
     * @throws InstantiationException
     * @throws NoSuchMethodException
     */

    public double calWrapper(String wellid,String sgt, double stroke, int sgtIsLegal,double frequence, String eczdjg,String zdjg,double
            bj,double bs,double hsl,double smd,double ymd,double qyb,double dym,double pzxs,double nd)   {
        double rcyl1 = 0;
        String oneStr =  baseDataClient.getByWellId_Heavy(wellid);
        Result result = JSONObject.parseObject(oneStr, Result.class);
        Object resultedata = result.getData();
        if (resultedata != null) {

            rcyl1 = cal2(sgt,stroke,sgtIsLegal,frequence,eczdjg,zdjg,bj,bs,hsl,smd,ymd,qyb,dym,pzxs,nd);
        }
        else {
            rcyl1 = cal(sgt,stroke,sgtIsLegal,frequence,eczdjg,zdjg,bj,bs,hsl,smd,ymd,qyb,dym,pzxs);
        }
        return   rcyl1;

    }

    /**
     * 稀油量液
     * @param sgt1
     * @param stroke
     * @param sgtIsLegal
     * @param frequence
     * @param eczdjg
     * @param zdjg
     * @param bj
     * @param bs
     * @param hsl
     * @param smd
     * @param ymd
     * @param qyb
     * @param dym
     * @param pzxs
     * @throws InstantiationException
     * @throws IllegalAccessException
     * @throws InvocationTargetException
     * @throws NoSuchMethodException
     */
    public double cal(String sgt1, double stroke, int sgtIsLegal,double frequence, String eczdjg,String zdjg,double
            bj,double bs,double hsl,double smd,double ymd,double qyb,double dym,double pzxs) {


        double rcyl1 =0;
        AoidSinglewellConfig effectStrockModel = aoidSinglewellConfigService.getConfigOneObjByID(1);
        Double[][] bgt = null;
        Double[][] sgt = sgt1 == null ? null : SGTUtil.encodeToDoubleArray(sgt1);

        bgt = calPumpCard.cal_bgt(sgt, stroke, sgtIsLegal, 1.0, eczdjg);


        if (bgt!=null)
        {
            CalDiagramProduction.CalProductionResult production = new CalDiagramProduction.CalProductionResult();
            production = calDiagramProduction.calProduction(
                    sgt, bgt, stroke, frequence, zdjg, bj, bs, hsl, smd, ymd, qyb, dym, pzxs, effectStrockModel
            );
            rcyl1= production.rcyl1;
        }




        return  rcyl1;
        //endregion
    }


    /**
     * 稠油量液算法
     * @param sgt1
     * @param stroke
     * @param sgtIsLegal
     * @param frequence
     * @param eczdjg
     * @param zdjg
     * @param bj
     * @param bs
     * @param hsl
     * @param smd
     * @param ymd
     * @param qyb
     * @param dym
     * @param pzxs
     * @return
     * @throws InstantiationException
     * @throws IllegalAccessException
     * @throws InvocationTargetException
     * @throws NoSuchMethodException
     */
    public double cal2(String sgt1, double stroke, int sgtIsLegal,double frequence, String eczdjg,String zdjg,double
            bj,double bs,double hsl,double smd,double ymd,double qyb,double dym,double pzxs,double nd) {

        List<Double[]> bgt_correct;
        CalDiagramProductionCopy algorithm_new = new CalDiagramProductionCopy();
        boolean isPumpAndGush;
        double impulse = 1;//默认冲次
        double rcyl1 =0;
        Double s_min =0.0;
        AoidGkHeavyModel model = null;
        model = aoidGkHeavyModelService.getGKModel_HeavyByResultType(eczdjg);
        if (Objects.nonNull(eczdjg)) {

            model = aoidGkHeavyModelService.getGKModel_HeavyByResultType(eczdjg);
        }
        Integer modelparamValue =0;
        if (Objects.isNull(model) || Objects.isNull(model.getModelparam()))
        {
            modelparamValue =1;
        }
        else
        {
            modelparamValue = model.getModelparam();
        }


        if ("喷抽".equals(eczdjg))
        {
            isPumpAndGush = true;
        }
        else
        {
            isPumpAndGush = false;
        }
        Double[][] bgt = null;
        List<Double[]> sgt_correct = SGTUtil.encodeToView(sgt1);
        CalPumpCardCopy calPumpCard = new CalPumpCardCopy();
        bgt = calPumpCard.cal_bgt(
                sgt_correct.toArray(new Double[][]{}),
                stroke,
                s_min,
                sgtIsLegal,
                impulse,//TODO:冲次影响阻尼计算 暂时默认传入1
                isPumpAndGush,
                bs,
                nd, //TODO: 传入真实的原油粘度数据
                null);

        bgt_correct = new ArrayList<>();
        for (int i = 0; i < bgt.length; i++) {
            bgt_correct.add(new Double[]{bgt[i][0], bgt[i][1]});
        }
        CalDiagramProductionCopy.CalProductionResult production = new CalDiagramProductionCopy.CalProductionResult();

        production = algorithm_new.calProduction(
                bgt_correct.toArray(new Double[][]{}),
                stroke,
                impulse,
                isPumpAndGush,
                bj,
                bs,
                hsl,
                smd,
                ymd,
                qyb,
                pzxs,
                modelparamValue
        );
        rcyl1= production.rcyl1;
        return rcyl1;
    }
}
