package com.gct.aoid;

import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.gct.aoid.entity.AoidDailyYield;
import com.gct.aoid.entity.AoidSinglegtYield;
import com.gct.aoid.feignclient.BaseDataClient;
import com.gct.aoid.feignclient.DiagnoseClient;
import com.gct.aoid.rocketmq.AoidMsg;
import com.gct.aoid.service.*;
import com.gct.aoid.service.impl.CalDiagramProductionService;
import com.gct.common.core.result.Result;
import com.gct.common.util.DateTimeUtil;
import lombok.extern.slf4j.Slf4j;
import org.junit.Test;
import org.junit.runner.RunWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.test.context.ContextConfiguration;
import org.springframework.test.context.junit4.SpringRunner;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.nio.charset.StandardCharsets;
import java.util.ArrayList;
import java.util.List;

/**
 * class name: testRef
 *
 * @author lloyd
 * @version 1.0
 * @since 2021/1/29 下午9:53
 */
@Slf4j
@SpringBootTest(classes = ProductionCalApplication.class)
@RunWith(SpringRunner.class)
@ContextConfiguration
public class TestRef {

    @Autowired
    AoidLiquidAbnormalDynamicService aoidLiquidAbnormalDynamicService;

    @Autowired
    AoidLiquidThresholdService aoidLiquidThresholdService;

    @Autowired
    LiqProdDailyCalService liqProdDailyCalService;
    @Autowired
    BaseDataClient baseDataClient;

    @Autowired
    AoidSinglegtYieldService aoidSinglegtYieldService;
    @Autowired
    AoidDailyYieldService aoidDailyYieldService;
    @Autowired
    DiagnoseClient diagnoseClient;
    @Autowired
    CalDiagramProductionService calDiagramProductionService;

    @Test
    public void test() throws Exception {
        for (int i = 0; i <= 2; i++) {
            //File file = new File("/home/gxt/下载/TXT/fsdownload/daily"+DateTimeUtil.formatDate("2022-09-20").plusDays(i)+".txt");
            File file = new File("/home/gxt/下载/TXT/fsdownload/singlegt"+DateTimeUtil.formatDate("2022-09-20").plusDays(i)+".txt");
            FileInputStream fis = new FileInputStream(file);
            InputStreamReader isr = new InputStreamReader(fis, StandardCharsets.UTF_8);
            BufferedReader br = new BufferedReader(isr);
            String line;
            List<AoidSinglegtYield> singlegtYields = new ArrayList<>();
            List<AoidDailyYield> dailyYields = new ArrayList<>();
            while((line = br.readLine()) != null){
                AoidSinglegtYield aoidSinglegtYield = JSONObject.parseObject(line, AoidSinglegtYield.class);
                //AoidDailyYield aoidDailyYield = JSONObject.parseObject(line, AoidDailyYield.class);
                singlegtYields.add(aoidSinglegtYield);
                //dailyYields.add(aoidDailyYield);
                if (singlegtYields.size() >= 1000){
                    aoidSinglegtYieldService.saveBatch(singlegtYields);
                    singlegtYields.clear();
                }
               /* if (dailyYields.size() >= 1000){
                    aoidDailyYieldService.saveBatch(dailyYields);
                    dailyYields.clear();
                }*/
            }
            br.close();

        }
    }

    @Test
    public void test1(){
        AoidMsg.DiagnoseResult diagnoseResult = JSONObject.parseObject(JSONObject.parseObject
                (diagnoseClient.getSingleDiagramDiagnoseResultByID("2734500a-bb0b-43bb-9f8d-8658d9d9f946"),
                Result.class).getData().toString(), AoidMsg.DiagnoseResult.class);
        AoidMsg.BaseParam baseParam = JSONObject.parseObject(JSONObject.parseObject
                (diagnoseClient.getDiagramCardBaseParamByID("33f4780a62554efae0c3b5f990633178"),
                Result.class).getData().toString(), AoidMsg.BaseParam.class);
        com.gct.aoid.rocketmq.AoidMsg aoidMsg = new com.gct.aoid.rocketmq.AoidMsg();
        aoidMsg.setBaseParam(baseParam);
        aoidMsg.setDiagnoseResult(diagnoseResult);
        calDiagramProductionService.calWrapper(aoidMsg);
    }

    @Test
    public void test2() {
        List<AoidSinglegtYield> list = aoidSinglegtYieldService.getBaseMapper().selectList(new LambdaQueryWrapper<AoidSinglegtYield>()
                .eq(AoidSinglegtYield::getWellId, "H2472")
                .ge(AoidSinglegtYield::getProdDate, DateTimeUtil.formatDateTime("2022-09-19 08:00:00"))
                .le(AoidSinglegtYield::getProdDate, DateTimeUtil.formatDateTime("2022-09-20 08:00:00")));
        liqProdDailyCalService.calculate(list,DateTimeUtil.formatDateTime("2022-09-14 00:00:00"),DateTimeUtil.formatDateTime("2022-09-14 00:00:00"),null);
    }

    public static void main(String[] args) throws Exception {

    }
}
